from src.einstellungen import *
import RPi.GPIO as GPIO
import time
import threading
import math

GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
 
class motor():

    def __init__(self, name, sp1, sp2, sp3, sp4, t1, t2, te, es, halten, schritte):
        self.name = name
        self.sp1 = sp1
        self.sp2 = sp2
        self.sp3 = sp3
        self.sp4 = sp4
        self.t1 = t1
        self.t2 = t2
        self.te = te
        self.endschalter = es
        self.halten = halten
        self.schritte_max = schritte
        self.pos = 0
        self.freq = freq
        self.freq_halten = freq_halten
        self.cyc_halten = cyc_halten
        self.pwm1 = 0
        self.pwm2 = 0
        self.pwm3 = 0
        self.pwm4 = 0

    def start(self):
        GPIO.setup(self.sp1, GPIO.OUT)
        GPIO.setup(self.sp2, GPIO.OUT)
        GPIO.setup(self.sp3, GPIO.OUT)
        GPIO.setup(self.sp4, GPIO.OUT)

        self.pwm1 = GPIO.PWM(self.sp1, self.freq)
        self.pwm1.start(0)
        
        self.pwm2 = GPIO.PWM(self.sp2, self.freq)
        self.pwm2.start(0)
        
        self.pwm3 = GPIO.PWM(self.sp3, self.freq)
        self.pwm3.start(0)
        
        if self.halten == 1:
            self.pwm4 = GPIO.PWM(self.sp4, self.freq_halten)
            self.pwm4.start(cyc_halten)
        else:
            self.pwm4 = GPIO.PWM(self.sp4, self.freq)
            self.pwm4.start(0)

    def stop(self):
        self.pwm1.stop()
        self.pwm2.stop()
        self.pwm3.stop()
        self.pwm4.stop()

    def vorwaerts(self, schritte, eichen=0):
        ges_schritte = schritte * 8

        if eichen == 1:
            temp_t1 = self.te
            temp_t2 = self.te
        else:
            temp_t1 = self.t1
            temp_t2 = self.t2
       
        if self.halten == 1:
            self.pwm4.ChangeFrequency(self.freq)

        for i in range(int(schritte)):
            if self.pos >= self.schritte_max:
                break
            else:
                self.pos += 1

            temp_pos = i * 8
            einzelschritt(self.pwm1, 1, ges_schritte, temp_pos, temp_t1, temp_t2)
            einzelschritt(self.pwm4, 0, ges_schritte, temp_pos + 1, temp_t1, temp_t2)
            einzelschritt(self.pwm2, 1, ges_schritte, temp_pos + 2, temp_t1, temp_t2)
            einzelschritt(self.pwm1, 0, ges_schritte, temp_pos + 3, temp_t1, temp_t2)
            einzelschritt(self.pwm3, 1, ges_schritte, temp_pos + 4, temp_t1, temp_t2)
            einzelschritt(self.pwm2, 0, ges_schritte, temp_pos + 5, temp_t1, temp_t2)
            einzelschritt(self.pwm4, 1, ges_schritte, temp_pos + 6, temp_t1, temp_t2)
            einzelschritt(self.pwm3, 0, ges_schritte, temp_pos + 7, temp_t1, temp_t2)

            print(str(self.pos))

        if self.halten == 1:
            self.pwm4.ChangeFrequency(self.freq_halten)
            self.pwm4.ChangeDutyCycle(self.cyc_halten)
        else:
            self.pwm4.ChangeDutyCycle(0)

    def rueckwaerts(self, schritte, eichen=0):
        ges_schritte = schritte * 8

        if eichen == 1:
            temp_t1 = self.te
            temp_t2 = self.te
        else:
            temp_t1 = self.t1
            temp_t2 = self.t2

        if self.halten == 1:
            self.pwm4.ChangeFrequency(self.freq)

        for i in range(int(schritte)):
            if GPIO.input(self.endschalter) == GPIO.LOW:
                print('Endschalter ' + self.name)
                self.pos = 0
                break
            else:
                self.pos -= 1

            temp_pos = i * 8
            einzelschritt(self.pwm3, 1, ges_schritte, temp_pos, temp_t1, temp_t2)
            einzelschritt(self.pwm4, 0, ges_schritte, temp_pos + 1, temp_t1, temp_t2)
            einzelschritt(self.pwm2, 1, ges_schritte, temp_pos + 2, temp_t1, temp_t2)
            einzelschritt(self.pwm3, 0, ges_schritte, temp_pos + 3, temp_t1, temp_t2)
            einzelschritt(self.pwm1, 1, ges_schritte, temp_pos + 4, temp_t1, temp_t2)
            einzelschritt(self.pwm2, 0, ges_schritte, temp_pos + 5, temp_t1, temp_t2)
            einzelschritt(self.pwm4, 1, ges_schritte, temp_pos + 6, temp_t1, temp_t2)
            einzelschritt(self.pwm1, 0, ges_schritte, temp_pos + 7, temp_t1, temp_t2)

            print(str(self.pos))

        if self.halten == 1:
            self.pwm4.ChangeFrequency(self.freq_halten)
            self.pwm4.ChangeDutyCycle(self.cyc_halten)
        else:
            self.pwm4.ChangeDutyCycle(0)

    def eichen(self):
        if GPIO.input(self.endschalter) == GPIO.LOW:
            self.vorwaerts(10, 1)

        self.rueckwaerts(self.schritte_max, 1)
        self.pos = 0

    def gehe_zu(self, position):
        temp_schritte = int(position) - self.pos
        print(str(temp_schritte))

        if temp_schritte > 0:
            self.vorwaerts(temp_schritte, 1)
        else:
            self.rueckwaerts(abs(temp_schritte))

def einzelschritt(spule, status, ges_schritte, schritt, t1, t2):
    w = (schritt * 100 / (ges_schritte - 1)) * 1.8
    s = round(math.sin(math.radians(w)), 2)
    t = t2 - (s * (t2 - t1))

    if status == 1:
        for i in range(0, 91, 5):
            dc = round(math.sin(math.radians(i)) * 100, 0)
            spule.ChangeDutyCycle(dc)
            time.sleep(t)
    else:
        for i in range(0, 91, 5):
            dc = round(math.cos(math.radians(i)) * 100, 0)
            spule.ChangeDutyCycle(dc)
            time.sleep(t)
